using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Sirenix.OdinInspector;

namespace KairoEngine.UI.ActivityMessages
{
    [System.Serializable]
    public class ActivityMessageGroup
    {
        [FoldoutGroup("@title")]
        public string title = "Group 1";

        [FoldoutGroup("@title"), Tooltip("The container that will hold the activity message GameObjects in this group.")]
        public Transform container;

        [FoldoutGroup("@title"), LabelText("Max Visible")] public int maxVisibleMessages = 100;
        [FoldoutGroup("@title"), LabelText("Max History")] public int maxHistoryMessages = 250;

        [FoldoutGroup("@title"), PropertySpace(4,0)] public List<ActivityMessage> messages;
    }
}
