﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Sirenix.OdinInspector;

namespace KairoEngine.UI
{
    [System.Serializable]
    public class MenuButtomData
    {
        [HideInInspector] public string name { get { return $"{parent}{(useSubMenus ? "/" : string.Empty)}{title}"; } }
        [FoldoutGroup("@name")] public string title = "";
        [FoldoutGroup("@name")] public string action= "";
        [FoldoutGroup("@name")] public Sprite graphic;
        [FoldoutGroup("@name")] public string description= "";
        [FoldoutGroup("@name")] public bool showTooltip = true;
        [FoldoutGroup("@name"), ShowIf("@showTooltip")] public string tooltipType = "";
        [FoldoutGroup("@name")] public bool isInteractable = true;
        [HideInInspector] public bool useSubMenus = true;
        [FoldoutGroup("@name"), Tooltip("Title of the parent button."), ShowIf("@useSubMenus")] public string parent= "";
        [FoldoutGroup("@name"), Tooltip("Is this button the parent of other buttons?"), ShowIf("@useSubMenus")] public bool subMenuParent = false;
        [FoldoutGroup("@name")] public GameObject button;
    }
}

